# LRS: Projects Needed

WIP

Here is a list of some projects and project ideas which we, [LRS](lrs.md), need to make in order to pursue our goals. The projects here are mostly basic things and tools that already exist in some form, but that have to be made from scratch according to [LRS](lrs.md) philosophy, i.e. in a KISS/suckless way, under public domain, in a good language (C, comun, ...) etc. This is kind of a dirty list serving some rough organization. If you have the skills and will (or know someone who does), you may take inspiration here, pick one up and make it, or contribute to some of the projects listed here. Also note that it's still possible to make multiple projects of the same type, e.g. you may still create another chess engine even though we already have one, just watch out that this is justified (it should offer something worth the extra effort).

| what                                   | difficulty | implementation                  | by           |  status             | comment                                                         | similar/for now use       |
| -------------------------------------- | ---------- | ------------------------------- | ------------ | ------------------- | --------------------------------------------------------------- | ------------------------- |
| 2D image editor                        | mid?       |                                 |              |                     | KISS GIMP clone needed! Use LRS GUI lib. Glorified MS paint?    | ped, GIMP, classic colors |
| 2D raycasting engine (C)               | mid        | [raycastlib](raycastlib.md)     | drummyfish   | done                |                                                                 |                           |
| 3D modelling software                  | mid/hard?  |                                 |              |                     | Blender clone needed! LRS GUI lib + small3dlib, just .obj files | Blender :(                |
| 3D physics engine (C)                  | hard       | [tinyphysicsengine](tpe.md)     | drummyfish   | done                | could use a true rigid body one too                             |                           |
| 3D raytracing library                  | mid?       |                                 |              | had vague plans     |C lib for shooting 3D rays, allows raycast., RT, pathtr., ...    | POV-RAY                   |
| 3D renderer (C)                        | mid/hard   | [small3dlib](small3dlib.md)     | drummyfish   | done                |                                                                 | TinyGL, PortableGL        |
| 3D voxel renderer (C)                  | mid/hard?  |                                 |              |                     | like Ken Silverman's voxlap, looks very nice                    | voxlap                    |
| audio/music editor                     | mid/hard?  |                                 |              |                     | for waveforms and/or MIDI (tracker music), can even be CLI/TUI  | Audacity, LMMS, ...       |
| Arduino/Pokitto/... computer           | mid/hard?  |                                 |              |                     | until we have PD computer, we'll need a nice tiny embedded comp.|                           |
| [BSP](bsp.md) "pseudo 3D" renderer (C) | mid/hard?  |                                 |              |                     | for Anarch II? :)                                               | Doom engine, BUILD        |
| [chess](chess.md) engine/library (C)   | mid/hard   |[smallchesslib](smallchesslib.md)| drummyfish   | done                | it's not very strong tho :/                                     |                           |
| [compression](compression.md) lib/util | mid?       |[shitpress](shitpress.md), ...   | ...          |one so far           |                                                                 |                           |
| data, datasets                         | easy/mid?  |                                 |              |can never have enough|simple format CC0 data (CSV etc.): txt dictionaries, star DB, ...| Wikidata, ...             |
| [free universes](free_universe.md)     | mid/hard?  |                                 |              |                     | need at least one fantasy and one sci-fi, for games n shit      |                           |
| fiction, stories, books                | mid?       |                                 |              |have some plans      | fairytales, sci-fi from LRS society etc.                        |                           |
| forum, chat, git/file host/mirror, ... | easy/mid?  |                                 |              |                     |for LRS community, if you have a server you could host something | email, IRC                |
| game engine/fantasy console (tiny)     | easy/mid   | [SAF](saf.md)                   | drummyfish   | done                |                                                                 |                           |
| game engine: point n click adventure   | mid        |                                 |              |                     |                                                                 |                           |
| game: [Doom](doom.md) clone            | hard       | [Anarch](anarch.md)             | drummyfish   | done                |                                                                 | Freedoom                  |
| game: [GTA](gta.md) clone              | hard       |                                 |              |                     |                                                                 |                           |
| game: [Minecraft](minecraft.md) clone  | hard?      |                                 |              |                     | Minetest is bloated as fuck, also bad license and SJWs          | Minetest :(               |
| game: text adventure                   | easy       |                                 |              |                     | pure CLI text adventure, maybe "US citizen simulator"? :)       |                           |
| game: [Trackmania](trackmania.md) clone| hard       | [Licar](licar.md)               | drummyfish   | started             |                                                                 |                           |
| game: [Pokemon](pokemon.md) clone      | hard?      |                                 |              |                     | catchable monsters game, procedurally generated ones? SAF?      | Tuxemon, ...              | 
| game: fantasy [RPG](rpg.md)            | hard?      |                                 |              |                     | Dream: Elder Scrolls clone, also just a dungeon crawler, ...    |                           |
| games: tiny ones                       | easy       | [uTD](micro_td.md), ...         | ...          |can never have enough| very tiny games, SAF is ideal for this, nice learning project   |                           |
| GUI library                            | easy/mid   |                                 |              |                     |like SAF but for "PC" GUI (mouse, sound, ...), now GUI's a mess  |                           |
| image/2D data library                  | mid?       |                                 |              |                     | C/comun lib for bitmaps (FFT, formats, ...), needs good planning|                           |
| nice polished concise encyclopedia     | mid/hard?  |                                 |              |                     | nice printable UNCENSORED encyclop. (clone of Larousse Desk E.) |                           |
| [go](go.md) engine/library (C or comun)| mid?       |                                 |              |                     |                                                                 |                           |
| logic circuit library/simulator (comun)| mid/hard?  |                                 |              |                     | will be needed for PD computer                                  |                           |
| neural net/other ML library            | hard?      |                                 |              |                     | could use something KISS in pure C without needed python n shit | nothing                   |
|[PD computer](public_domain_computer.md)| very hard  |                                 |              |                     | needs prerequisites done first (language, logic circ. lib., ...)|                           |
| PD computer "[operating system](os.md)"| mid?       |                                 |              |                     | not now, will be more like Pokitto loader (see OS article)      | Thinkpads :)              |
| propaganda materials                   | easy       |                                 |              |can never have enough|wallpapers, songs, videos, translations, tutorials, games, ...   |                           |
| programming language                   | mid/hard   | [comun](comun.md)               | drummyfish   | done, continuing    |                                                                 | C, comun, FORTH, ...      |
| [search engine](search_engine.md)      | mid/hard?  |                                 |              |                     |like wiby, marginalia, ... support gopher, KISS (no DB, just txt)| wiby, marginalia, ...     |
| soundfonts                             | easy/mid   |                                 |              |                     | nice CC0 soundfonts so we can make completely PD MIDI           |                           |
| text editor (C, comun)                 | mid?       |                                 |              |                     | likely more will be made, need a standard KISS editor in comun  |                           |
| vector fonts                           | mid?       | GirlsAreDumb, ...               | ...          | one done            | nice CC0 fonts for texts, there are too few of those            | Aileron, ...              |
| web (gopher, ...) browser              | easy/mid?  |                                 |              |                     | like badwolf basically, but yet nicer (support gopher etc.)     |badwolf, netsurf, lynx, ...|
| wiki                                   | mid        | [LRS wiki](lrs_wiki.md)         | drummyfish   | done, continuing    |                                                                 |                           |
